
varying vec2 v_texCoord0;
varying vec2 v_texCoord1;
varying vec3 v_L2dir;
         
uniform sampler2D u_texture; /* diffuse */
uniform sampler2D u_texture1; /* normal map */
uniform sampler2D u_texture2; /* normal map 2*/
         
uniform vec4 u_materialAmbient;
uniform vec4 u_materialDiffuse;
uniform vec4 u_materialSpecular;
uniform float u_materialShininess;
uniform vec4 u_color4;

void main()
{
	vec4 col = texture2D(u_texture, v_texCoord0);
	vec4 normalMap1 = texture2D(u_texture1, v_texCoord0);
	vec4 normalMap2 = texture2D(u_texture1, v_texCoord1);
	vec4 normalMap = normalMap1 + normalMap2;			//combine normalmaps here
	vec3 normal = normalMap.rgb - 1.0;
	
	float nDotL2 = abs(dot(v_L2dir, normal));
	
	const float intensityL2 = 1.0;
	float atten = nDotL2 * intensityL2;
	
	float specular = pow(nDotL2, u_materialShininess * 1.0) * intensityL2;
	
	col.rgb *= u_materialDiffuse.rgb * atten + u_materialAmbient.rgb;
	col.rgb += u_materialSpecular.rgb * (specular * normalMap.a);
	col.rgb *= u_materialAmbient.a;
	
	gl_FragColor = col * u_color4;
}