//varying lowp vec4 v_color;
varying lowp vec2 v_texCoord;
varying lowp vec3 v_normal;
varying lowp mat4 v_viewMatrix;
varying lowp float v_vdn;

uniform sampler2D u_texture;
uniform lowp vec4 RimBleed;
uniform mediump vec4 u_color4;
uniform mediump vec4 u_materialAmbient;

void main() {
	vec4 texColor = texture2D(u_texture, v_texCoord);
	float angleDifference = smoothstep(RimBleed.x, 1.0, v_vdn);
	gl_FragColor = mix(texColor * u_color4, texColor * (u_materialAmbient + 0.1) * 10.0, angleDifference);
}